'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _spread = require('../../utils/spread.js');

var _spread2 = _interopRequireDefault(_spread);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ArrayExpression = function (_Node) {
	_inherits(ArrayExpression, _Node);

	function ArrayExpression() {
		_classCallCheck(this, ArrayExpression);

		return _possibleConstructorReturn(this, (ArrayExpression.__proto__ || Object.getPrototypeOf(ArrayExpression)).apply(this, arguments));
	}

	_createClass(ArrayExpression, [{
		key: 'initialise',
		value: function initialise(transforms) {
			if (transforms.spreadRest && this.elements.length) {
				var lexicalBoundary = this.findLexicalBoundary();

				var i = this.elements.length;
				while (i--) {
					var element = this.elements[i];
					if (element && element.type === 'SpreadElement' && (0, _spread.isArguments)(element.argument)) {
						this.argumentsArrayAlias = lexicalBoundary.getArgumentsArrayAlias();
					}
				}
			}

			_get(ArrayExpression.prototype.__proto__ || Object.getPrototypeOf(ArrayExpression.prototype), 'initialise', this).call(this, transforms);
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			_get(ArrayExpression.prototype.__proto__ || Object.getPrototypeOf(ArrayExpression.prototype), 'transpile', this).call(this, code, transforms);

			if (transforms.spreadRest) {
				// erase trailing comma after last array element if not an array hole
				if (this.elements.length) {
					var lastElement = this.elements[this.elements.length - 1];
					if (lastElement && /\s*,/.test(code.original.slice(lastElement.end, this.end))) {
						code.overwrite(lastElement.end, this.end - 1, ' ');
					}
				}

				if (this.elements.length === 1) {
					var element = this.elements[0];

					if (element && element.type === 'SpreadElement') {
						// special case – [ ...arguments ]
						if ((0, _spread.isArguments)(element.argument)) {
							code.overwrite(this.start, this.end, '[].concat( ' + this.argumentsArrayAlias + ' )'); // TODO if this is the only use of argsArray, don't bother concating
						} else {
							code.overwrite(this.start, element.argument.start, '[].concat( ');
							code.overwrite(element.end, this.end, ' )');
						}
					}
				} else {
					var hasSpreadElements = (0, _spread2.default)(code, this.elements, this.start, this.argumentsArrayAlias);

					if (hasSpreadElements) {
						code.overwrite(this.end - 1, this.end, ')');
					}
				}
			}
		}
	}]);

	return ArrayExpression;
}(_Node3.default);

exports.default = ArrayExpression;