'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _CompileError = require('../../utils/CompileError.js');

var _CompileError2 = _interopRequireDefault(_CompileError);

var _patterns = require('../../utils/patterns.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BreakStatement = function (_Node) {
	_inherits(BreakStatement, _Node);

	function BreakStatement() {
		_classCallCheck(this, BreakStatement);

		return _possibleConstructorReturn(this, (BreakStatement.__proto__ || Object.getPrototypeOf(BreakStatement)).apply(this, arguments));
	}

	_createClass(BreakStatement, [{
		key: 'initialise',
		value: function initialise() {
			var loop = this.findNearest(_patterns.loopStatement);
			var switchCase = this.findNearest('SwitchCase');

			if (loop && (!switchCase || loop.depth > switchCase.depth)) {
				loop.canBreak = true;
				this.loop = loop;
			}
		}
	}, {
		key: 'transpile',
		value: function transpile(code) {
			if (this.loop && this.loop.shouldRewriteAsFunction) {
				if (this.label) throw new _CompileError2.default('Labels are not currently supported in a loop with locally-scoped variables', this);
				code.overwrite(this.start, this.start + 5, 'return \'break\'');
			}
		}
	}]);

	return BreakStatement;
}(_Node3.default);

exports.default = BreakStatement;