'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _spread = require('../../utils/spread.js');

var _spread2 = _interopRequireDefault(_spread);

var _removeTrailingComma = require('../../utils/removeTrailingComma.js');

var _removeTrailingComma2 = _interopRequireDefault(_removeTrailingComma);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CallExpression = function (_Node) {
	_inherits(CallExpression, _Node);

	function CallExpression() {
		_classCallCheck(this, CallExpression);

		return _possibleConstructorReturn(this, (CallExpression.__proto__ || Object.getPrototypeOf(CallExpression)).apply(this, arguments));
	}

	_createClass(CallExpression, [{
		key: 'initialise',
		value: function initialise(transforms) {
			if (transforms.spreadRest && this.arguments.length > 1) {
				var lexicalBoundary = this.findLexicalBoundary();

				var i = this.arguments.length;
				while (i--) {
					var arg = this.arguments[i];
					if (arg.type === 'SpreadElement' && (0, _spread.isArguments)(arg.argument)) {
						this.argumentsArrayAlias = lexicalBoundary.getArgumentsArrayAlias();
					}
				}
			}

			_get(CallExpression.prototype.__proto__ || Object.getPrototypeOf(CallExpression.prototype), 'initialise', this).call(this, transforms);
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			if (transforms.spreadRest && this.arguments.length) {
				var hasSpreadElements = false;
				var context = void 0;

				var firstArgument = this.arguments[0];

				if (this.arguments.length === 1) {
					if (firstArgument.type === 'SpreadElement') {
						code.remove(firstArgument.start, firstArgument.argument.start);
						hasSpreadElements = true;
					}
				} else {
					hasSpreadElements = (0, _spread2.default)(code, this.arguments, firstArgument.start, this.argumentsArrayAlias);
				}

				if (hasSpreadElements) {
					// we need to handle super() and super.method() differently
					// due to its instance
					var _super = null;
					if (this.callee.type === 'Super') {
						_super = this.callee;
					} else if (this.callee.type === 'MemberExpression' && this.callee.object.type === 'Super') {
						_super = this.callee.object;
					}

					if (!_super && this.callee.type === 'MemberExpression') {
						if (this.callee.object.type === 'Identifier') {
							context = this.callee.object.name;
						} else {
							context = this.findScope(true).createDeclaration('ref');
							var callExpression = this.callee.object;
							code.prependRight(callExpression.start, '(' + context + ' = ');
							code.appendLeft(callExpression.end, ')');
						}
					} else {
						context = 'void 0';
					}

					code.appendLeft(this.callee.end, '.apply');

					if (_super) {
						_super.noCall = true; // bit hacky...

						if (this.arguments.length > 1) {
							if (firstArgument.type !== 'SpreadElement') {
								code.prependRight(firstArgument.start, '[ ');
							}

							code.appendLeft(this.arguments[this.arguments.length - 1].end, ' )');
						}
					} else if (this.arguments.length === 1) {
						code.prependRight(firstArgument.start, context + ', ');
					} else {
						if (firstArgument.type === 'SpreadElement') {
							code.appendLeft(firstArgument.start, context + ', ');
						} else {
							code.appendLeft(firstArgument.start, context + ', [ ');
						}

						code.appendLeft(this.arguments[this.arguments.length - 1].end, ' )');
					}
				}
			}

			if (transforms.trailingFunctionCommas && this.arguments.length) {
				(0, _removeTrailingComma2.default)(code, this.arguments[this.arguments.length - 1].end);
			}

			_get(CallExpression.prototype.__proto__ || Object.getPrototypeOf(CallExpression.prototype), 'transpile', this).call(this, code, transforms);
		}
	}]);

	return CallExpression;
}(_Node3.default);

exports.default = CallExpression;