'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _array = require('../../utils/array.js');

var _reserved = require('../../utils/reserved.js');

var _reserved2 = _interopRequireDefault(_reserved);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// TODO this code is pretty wild, tidy it up
var ClassBody = function (_Node) {
	_inherits(ClassBody, _Node);

	function ClassBody() {
		_classCallCheck(this, ClassBody);

		return _possibleConstructorReturn(this, (ClassBody.__proto__ || Object.getPrototypeOf(ClassBody)).apply(this, arguments));
	}

	_createClass(ClassBody, [{
		key: 'transpile',
		value: function transpile(code, transforms, inFunctionExpression, superName) {
			var _this2 = this;

			if (transforms.classes) {
				var name = this.parent.name;

				var indentStr = code.getIndentString();
				var i0 = this.getIndentation() + (inFunctionExpression ? indentStr : '');
				var i1 = i0 + indentStr;

				var constructorIndex = (0, _array.findIndex)(this.body, function (node) {
					return node.kind === 'constructor';
				});
				var _constructor = this.body[constructorIndex];

				var introBlock = '';
				var outroBlock = '';

				if (this.body.length) {
					code.remove(this.start, this.body[0].start);
					code.remove(this.body[this.body.length - 1].end, this.end);
				} else {
					code.remove(this.start, this.end);
				}

				if (_constructor) {
					_constructor.value.body.isConstructorBody = true;

					var previousMethod = this.body[constructorIndex - 1];
					var nextMethod = this.body[constructorIndex + 1];

					// ensure constructor is first
					if (constructorIndex > 0) {
						code.remove(previousMethod.end, _constructor.start);
						code.move(_constructor.start, nextMethod ? nextMethod.start : this.end - 1, this.body[0].start);
					}

					if (!inFunctionExpression) code.appendLeft(_constructor.end, ';');
				}

				var namedFunctions = this.program.options.namedFunctionExpressions !== false;
				var namedConstructor = namedFunctions || this.parent.superClass || this.parent.type !== 'ClassDeclaration';
				if (this.parent.superClass) {
					var inheritanceBlock = 'if ( ' + superName + ' ) ' + name + '.__proto__ = ' + superName + ';\n' + i0 + name + '.prototype = Object.create( ' + superName + ' && ' + superName + '.prototype );\n' + i0 + name + '.prototype.constructor = ' + name + ';';

					if (_constructor) {
						introBlock += '\n\n' + i0 + inheritanceBlock;
					} else {
						var fn = 'function ' + name + ' () {' + (superName ? '\n' + i1 + superName + '.apply(this, arguments);\n' + i0 + '}' : '}') + (inFunctionExpression ? '' : ';') + (this.body.length ? '\n\n' + i0 : '');

						inheritanceBlock = fn + inheritanceBlock;
						introBlock += inheritanceBlock + ('\n\n' + i0);
					}
				} else if (!_constructor) {
					var _fn = 'function ' + (namedConstructor ? name + ' ' : '') + '() {}';
					if (this.parent.type === 'ClassDeclaration') _fn += ';';
					if (this.body.length) _fn += '\n\n' + i0;

					introBlock += _fn;
				}

				var scope = this.findScope(false);

				var prototypeGettersAndSetters = [];
				var staticGettersAndSetters = [];
				var prototypeAccessors = void 0;
				var staticAccessors = void 0;

				this.body.forEach(function (method, i) {
					if (method.kind === 'constructor') {
						var constructorName = namedConstructor ? ' ' + name : '';
						code.overwrite(method.key.start, method.key.end, 'function' + constructorName);
						return;
					}

					if (method.static) {
						var len = code.original[method.start + 6] == ' ' ? 7 : 6;
						code.remove(method.start, method.start + len);
					}

					var isAccessor = method.kind !== 'method';
					var lhs = void 0;

					var methodName = method.key.name;
					if (_reserved2.default[methodName] || method.value.body.scope.references[methodName]) {
						methodName = scope.createIdentifier(methodName);
					}

					// when method name is a string or a number let's pretend it's a computed method

					var fake_computed = false;
					if (!method.computed && method.key.type === 'Literal') {
						fake_computed = true;
						method.computed = true;
					}

					if (isAccessor) {
						if (method.computed) {
							throw new Error('Computed accessor properties are not currently supported');
						}

						code.remove(method.start, method.key.start);

						if (method.static) {
							if (!~staticGettersAndSetters.indexOf(method.key.name)) staticGettersAndSetters.push(method.key.name);
							if (!staticAccessors) staticAccessors = scope.createIdentifier('staticAccessors');

							lhs = '' + staticAccessors;
						} else {
							if (!~prototypeGettersAndSetters.indexOf(method.key.name)) prototypeGettersAndSetters.push(method.key.name);
							if (!prototypeAccessors) prototypeAccessors = scope.createIdentifier('prototypeAccessors');

							lhs = '' + prototypeAccessors;
						}
					} else {
						lhs = method.static ? '' + name : name + '.prototype';
					}

					if (!method.computed) lhs += '.';

					var insertNewlines = constructorIndex > 0 && i === constructorIndex + 1 || i === 0 && constructorIndex === _this2.body.length - 1;

					if (insertNewlines) lhs = '\n\n' + i0 + lhs;

					var c = method.key.end;
					if (method.computed) {
						if (fake_computed) {
							code.prependRight(method.key.start, '[');
							code.appendLeft(method.key.end, ']');
						} else {
							while (code.original[c] !== ']') {
								c += 1;
							}c += 1;
						}
					}

					var funcName = method.computed || isAccessor || !namedFunctions ? '' : methodName + ' ';
					var rhs = (isAccessor ? '.' + method.kind : '') + ' = function' + (method.value.generator ? '* ' : ' ') + funcName;
					code.remove(c, method.value.start);
					code.prependRight(method.value.start, rhs);
					code.appendLeft(method.end, ';');

					if (method.value.generator) code.remove(method.start, method.key.start);

					code.prependRight(method.start, lhs);
				});

				if (prototypeGettersAndSetters.length || staticGettersAndSetters.length) {
					var intro = [];
					var outro = [];

					if (prototypeGettersAndSetters.length) {
						intro.push('var ' + prototypeAccessors + ' = { ' + prototypeGettersAndSetters.map(function (name) {
							return name + ': { configurable: true }';
						}).join(',') + ' };');
						outro.push('Object.defineProperties( ' + name + '.prototype, ' + prototypeAccessors + ' );');
					}

					if (staticGettersAndSetters.length) {
						intro.push('var ' + staticAccessors + ' = { ' + staticGettersAndSetters.map(function (name) {
							return name + ': { configurable: true }';
						}).join(',') + ' };');
						outro.push('Object.defineProperties( ' + name + ', ' + staticAccessors + ' );');
					}

					if (_constructor) introBlock += '\n\n' + i0;
					introBlock += intro.join('\n' + i0);
					if (!_constructor) introBlock += '\n\n' + i0;

					outroBlock += '\n\n' + i0 + outro.join('\n' + i0);
				}

				if (_constructor) {
					code.appendLeft(_constructor.end, introBlock);
				} else {
					code.prependRight(this.start, introBlock);
				}

				code.appendLeft(this.end, outroBlock);
			}

			_get(ClassBody.prototype.__proto__ || Object.getPrototypeOf(ClassBody.prototype), 'transpile', this).call(this, code, transforms);
		}
	}]);

	return ClassBody;
}(_Node3.default);

exports.default = ClassBody;