'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _deindent = require('../../utils/deindent.js');

var _deindent2 = _interopRequireDefault(_deindent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ClassDeclaration = function (_Node) {
	_inherits(ClassDeclaration, _Node);

	function ClassDeclaration() {
		_classCallCheck(this, ClassDeclaration);

		return _possibleConstructorReturn(this, (ClassDeclaration.__proto__ || Object.getPrototypeOf(ClassDeclaration)).apply(this, arguments));
	}

	_createClass(ClassDeclaration, [{
		key: 'initialise',
		value: function initialise(transforms) {
			if (this.id) {
				this.name = this.id.name;
				this.findScope(true).addDeclaration(this.id, 'class');
			} else {
				this.name = this.findScope(true).createIdentifier("defaultExport");
			}

			_get(ClassDeclaration.prototype.__proto__ || Object.getPrototypeOf(ClassDeclaration.prototype), 'initialise', this).call(this, transforms);
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			if (transforms.classes) {
				if (!this.superClass) (0, _deindent2.default)(this.body, code);

				var superName = this.superClass && (this.superClass.name || 'superclass');

				var i0 = this.getIndentation();
				var i1 = i0 + code.getIndentString();

				// if this is an export default statement, we have to move the export to
				// after the declaration, because `export default var Foo = ...` is illegal
				var isExportDefaultDeclaration = this.parent.type === 'ExportDefaultDeclaration';

				if (isExportDefaultDeclaration) {
					code.remove(this.parent.start, this.start);
				}

				var c = this.start;
				if (this.id) {
					code.overwrite(c, this.id.start, 'var ');
					c = this.id.end;
				} else {
					code.prependLeft(c, 'var ' + this.name);
				}

				if (this.superClass) {
					if (this.superClass.end === this.body.start) {
						code.remove(c, this.superClass.start);
						code.appendLeft(c, ' = (function (' + superName + ') {\n' + i1);
					} else {
						code.overwrite(c, this.superClass.start, ' = ');
						code.overwrite(this.superClass.end, this.body.start, '(function (' + superName + ') {\n' + i1);
					}
				} else {
					if (c === this.body.start) {
						code.appendLeft(c, ' = ');
					} else {
						code.overwrite(c, this.body.start, ' = ');
					}
				}

				this.body.transpile(code, transforms, !!this.superClass, superName);

				var syntheticDefaultExport = isExportDefaultDeclaration ? '\n\n' + i0 + 'export default ' + this.name + ';' : '';
				if (this.superClass) {
					code.appendLeft(this.end, '\n\n' + i1 + 'return ' + this.name + ';\n' + i0 + '}(');
					code.move(this.superClass.start, this.superClass.end, this.end);
					code.prependRight(this.end, '));' + syntheticDefaultExport);
				} else if (syntheticDefaultExport) {
					code.prependRight(this.end, syntheticDefaultExport);
				}
			} else {
				this.body.transpile(code, transforms, false, null);
			}
		}
	}]);

	return ClassDeclaration;
}(_Node3.default);

exports.default = ClassDeclaration;