'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _LoopStatement2 = require('./shared/LoopStatement.js');

var _LoopStatement3 = _interopRequireDefault(_LoopStatement2);

var _extractNames = require('../extractNames.js');

var _extractNames2 = _interopRequireDefault(_extractNames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ForStatement = function (_LoopStatement) {
	_inherits(ForStatement, _LoopStatement);

	function ForStatement() {
		_classCallCheck(this, ForStatement);

		return _possibleConstructorReturn(this, (ForStatement.__proto__ || Object.getPrototypeOf(ForStatement)).apply(this, arguments));
	}

	_createClass(ForStatement, [{
		key: 'findScope',
		value: function findScope(functionScope) {
			return functionScope || !this.createdScope ? this.parent.findScope(functionScope) : this.body.scope;
		}
	}, {
		key: 'transpile',
		value: function transpile(code, transforms) {
			var _this2 = this;

			var i1 = this.getIndentation() + code.getIndentString();

			if (this.shouldRewriteAsFunction) {
				// which variables are declared in the init statement?
				var names = this.init.type === 'VariableDeclaration' ? [].concat.apply([], this.init.declarations.map(function (declarator) {
					return (0, _extractNames2.default)(declarator.id);
				})) : [];

				var aliases = this.aliases;

				this.args = names.map(function (name) {
					return name in _this2.aliases ? _this2.aliases[name].outer : name;
				});
				this.params = names.map(function (name) {
					return name in _this2.aliases ? _this2.aliases[name].inner : name;
				});

				var updates = Object.keys(this.reassigned).map(function (name) {
					return aliases[name].outer + ' = ' + aliases[name].inner + ';';
				});

				if (updates.length) {
					if (this.body.synthetic) {
						code.appendLeft(this.body.body[0].end, '; ' + updates.join(' '));
					} else {
						var lastStatement = this.body.body[this.body.body.length - 1];
						code.appendLeft(lastStatement.end, '\n\n' + i1 + updates.join('\n' + i1));
					}
				}
			}

			_get(ForStatement.prototype.__proto__ || Object.getPrototypeOf(ForStatement.prototype), 'transpile', this).call(this, code, transforms);
		}
	}]);

	return ForStatement;
}(_LoopStatement3.default);

exports.default = ForStatement;