'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _isReference = require('../../utils/isReference.js');

var _isReference2 = _interopRequireDefault(_isReference);

var _patterns = require('../../utils/patterns.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Identifier = function (_Node) {
	_inherits(Identifier, _Node);

	function Identifier() {
		_classCallCheck(this, Identifier);

		return _possibleConstructorReturn(this, (Identifier.__proto__ || Object.getPrototypeOf(Identifier)).apply(this, arguments));
	}

	_createClass(Identifier, [{
		key: 'findScope',
		value: function findScope(functionScope) {
			if (this.parent.params && ~this.parent.params.indexOf(this)) {
				return this.parent.body.scope;
			}

			if (this.parent.type === 'FunctionExpression' && this === this.parent.id) {
				return this.parent.body.scope;
			}

			return this.parent.findScope(functionScope);
		}
	}, {
		key: 'initialise',
		value: function initialise(transforms) {
			if ((0, _isReference2.default)(this, this.parent)) {
				if (transforms.arrow && this.name === 'arguments' && !this.findScope(false).contains(this.name)) {
					var lexicalBoundary = this.findLexicalBoundary();
					var arrowFunction = this.findNearest('ArrowFunctionExpression');
					var loop = this.findNearest(_patterns.loopStatement);

					if (arrowFunction && arrowFunction.depth > lexicalBoundary.depth) {
						this.alias = lexicalBoundary.getArgumentsAlias();
					}

					if (loop && loop.body.contains(this) && loop.depth > lexicalBoundary.depth) {
						this.alias = lexicalBoundary.getArgumentsAlias();
					}
				}

				this.findScope(false).addReference(this);
			}
		}
	}, {
		key: 'transpile',
		value: function transpile(code) {
			if (this.alias) {
				code.overwrite(this.start, this.end, this.alias, {
					storeName: true,
					contentOnly: true
				});
			}
		}
	}]);

	return Identifier;
}(_Node3.default);

exports.default = Identifier;