'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _Node2 = require('../Node.js');

var _Node3 = _interopRequireDefault(_Node2);

var _CompileError = require('../../utils/CompileError.js');

var _CompileError2 = _interopRequireDefault(_CompileError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ObjectExpression = function (_Node) {
	_inherits(ObjectExpression, _Node);

	function ObjectExpression() {
		_classCallCheck(this, ObjectExpression);

		return _possibleConstructorReturn(this, (ObjectExpression.__proto__ || Object.getPrototypeOf(ObjectExpression)).apply(this, arguments));
	}

	_createClass(ObjectExpression, [{
		key: 'transpile',
		value: function transpile(code, transforms) {
			_get(ObjectExpression.prototype.__proto__ || Object.getPrototypeOf(ObjectExpression.prototype), 'transpile', this).call(this, code, transforms);

			var firstPropertyStart = this.start + 1;
			var regularPropertyCount = 0;
			var spreadPropertyCount = 0;
			var computedPropertyCount = 0;
			var firstSpreadProperty = null;
			var firstComputedProperty = null;

			for (var i = 0; i < this.properties.length; ++i) {
				var prop = this.properties[i];
				if (prop.type === 'SpreadElement') {
					spreadPropertyCount += 1;
					if (firstSpreadProperty === null) firstSpreadProperty = i;
				} else if (prop.computed) {
					computedPropertyCount += 1;
					if (firstComputedProperty === null) firstComputedProperty = i;
				} else if (prop.type === 'Property') {
					regularPropertyCount += 1;
				}
			}

			if (spreadPropertyCount) {
				if (!this.program.options.objectAssign) {
					throw new _CompileError2.default("Object spread operator requires specified objectAssign option with 'Object.assign' or polyfill helper.", this);
				}
				// enclose run of non-spread properties in curlies
				var _i = this.properties.length;
				if (regularPropertyCount && !computedPropertyCount) {
					while (_i--) {
						var _prop = this.properties[_i];

						if (_prop.type === 'Property' && !_prop.computed) {
							var lastProp = this.properties[_i - 1];
							var nextProp = this.properties[_i + 1];

							if (!lastProp || lastProp.type !== 'Property' || lastProp.computed) {
								code.prependRight(_prop.start, '{');
							}

							if (!nextProp || nextProp.type !== 'Property' || nextProp.computed) {
								code.appendLeft(_prop.end, '}');
							}
						}
					}
				}

				// wrap the whole thing in Object.assign
				firstPropertyStart = this.properties[0].start;
				if (!computedPropertyCount) {
					code.overwrite(this.start, firstPropertyStart, this.program.options.objectAssign + '({}, ');
					code.overwrite(this.properties[this.properties.length - 1].end, this.end, ')');
				} else if (this.properties[0].type === 'SpreadElement') {
					code.overwrite(this.start, firstPropertyStart, this.program.options.objectAssign + '({}, ');
					code.remove(this.end - 1, this.end);
					code.appendRight(this.end, ')');
				} else {
					code.prependLeft(this.start, this.program.options.objectAssign + '(');
					code.appendRight(this.end, ')');
				}
			}

			if (computedPropertyCount && transforms.computedProperty) {
				var i0 = this.getIndentation();

				var isSimpleAssignment = void 0;
				var name = void 0;

				if (this.parent.type === 'VariableDeclarator' && this.parent.parent.declarations.length === 1 && this.parent.id.type === 'Identifier') {
					isSimpleAssignment = true;
					name = this.parent.id.alias || this.parent.id.name; // TODO is this right?
				} else if (this.parent.type === 'AssignmentExpression' && this.parent.parent.type === 'ExpressionStatement' && this.parent.left.type === 'Identifier') {
					isSimpleAssignment = true;
					name = this.parent.left.alias || this.parent.left.name; // TODO is this right?
				} else if (this.parent.type === 'AssignmentPattern' && this.parent.left.type === 'Identifier') {
					isSimpleAssignment = true;
					name = this.parent.left.alias || this.parent.left.name; // TODO is this right?
				}

				if (spreadPropertyCount) isSimpleAssignment = false;

				// handle block scoping
				name = this.findScope(false).resolveName(name);

				var start = firstPropertyStart;
				var end = this.end;

				if (isSimpleAssignment) {
					// ???
				} else {
					if (firstSpreadProperty === null || firstComputedProperty < firstSpreadProperty) {
						name = this.findScope(true).createDeclaration('obj');

						code.prependRight(this.start, '( ' + name + ' = ');
					} else name = null; // We don't actually need this variable
				}

				var len = this.properties.length;
				var lastComputedProp = void 0;
				var sawNonComputedProperty = false;
				var isFirst = true;

				for (var _i2 = 0; _i2 < len; _i2 += 1) {
					var _prop2 = this.properties[_i2];
					var moveStart = _i2 > 0 ? this.properties[_i2 - 1].end : start;

					if (_prop2.type === 'Property' && (_prop2.computed || lastComputedProp && !spreadPropertyCount)) {
						if (_i2 === 0) moveStart = this.start + 1; // Trim leading whitespace
						lastComputedProp = _prop2;

						if (!name) {
							name = this.findScope(true).createDeclaration('obj');

							var propId = name + (_prop2.computed ? '' : '.');
							code.appendRight(_prop2.start, '( ' + name + ' = {}, ' + propId);
						} else {
							var _propId = (isSimpleAssignment ? ';\n' + i0 + name : ', ' + name) + (_prop2.key.type === 'Literal' || _prop2.computed ? '' : '.');

							if (moveStart < _prop2.start) {
								code.overwrite(moveStart, _prop2.start, _propId);
							} else {
								code.prependRight(_prop2.start, _propId);
							}
						}

						var _c = _prop2.key.end;
						if (_prop2.computed) {
							while (code.original[_c] !== ']') {
								_c += 1;
							}_c += 1;
						}
						if (_prop2.key.type === 'Literal' && !_prop2.computed) {
							code.overwrite(_prop2.start, _prop2.key.end + 1, '[' + code.slice(_prop2.start, _prop2.key.end) + '] = ');
						} else if (_prop2.shorthand || _prop2.method && !_prop2.computed && transforms.conciseMethodProperty) {
							// Replace : with = if Property::transpile inserted the :
							code.overwrite(_prop2.key.start, _prop2.key.end, code.slice(_prop2.key.start, _prop2.key.end).replace(/:/, ' ='));
						} else {
							if (_prop2.value.start > _c) code.remove(_c, _prop2.value.start);
							code.prependLeft(_c, ' = ');
						}

						// This duplicates behavior from Property::transpile which is disabled
						// for computed properties or if conciseMethodProperty is false
						if (_prop2.method && (_prop2.computed || !transforms.conciseMethodProperty)) {
							if (_prop2.value.generator) code.remove(_prop2.start, _prop2.key.start);
							code.prependRight(_prop2.value.start, 'function' + (_prop2.value.generator ? '*' : '') + ' ');
						}
					} else if (_prop2.type === 'SpreadElement') {
						if (name && _i2 > 0) {
							if (!lastComputedProp) {
								lastComputedProp = this.properties[_i2 - 1];
							}
							code.appendLeft(lastComputedProp.end, ', ' + name + ' )');

							lastComputedProp = null;
							name = null;
						}
					} else {
						if (!isFirst && spreadPropertyCount) {
							// We are in an Object.assign context, so we need to wrap regular properties
							code.prependRight(_prop2.start, '{');
							code.appendLeft(_prop2.end, '}');
						}
						sawNonComputedProperty = true;
					}
					if (isFirst && (_prop2.type === 'SpreadElement' || _prop2.computed)) {
						var beginEnd = sawNonComputedProperty ? this.properties[this.properties.length - 1].end : this.end - 1;
						// Trim trailing comma because it can easily become a leading comma which is illegal
						if (code.original[beginEnd] == ',') ++beginEnd;
						var closing = code.slice(beginEnd, end);
						code.prependLeft(moveStart, closing);
						code.remove(beginEnd, end);
						isFirst = false;
					}

					// Clean up some extranous whitespace
					var c = _prop2.end;
					if (_i2 < len - 1 && !sawNonComputedProperty) {
						while (code.original[c] !== ',') {
							c += 1;
						}
					} else if (_i2 == len - 1) c = this.end;
					code.remove(_prop2.end, c);
				}

				// special case
				if (computedPropertyCount === len) {
					code.remove(this.properties[len - 1].end, this.end - 1);
				}

				if (!isSimpleAssignment && name) {
					code.appendLeft(lastComputedProp.end, ', ' + name + ' )');
				}
			}
		}
	}]);

	return ObjectExpression;
}(_Node3.default);

exports.default = ObjectExpression;