'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _locate = require('./locate.js');

var _locate2 = _interopRequireDefault(_locate);

var _getSnippet = require('./getSnippet.js');

var _getSnippet2 = _interopRequireDefault(_getSnippet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CompileError = function (_Error) {
	_inherits(CompileError, _Error);

	function CompileError(message, node) {
		_classCallCheck(this, CompileError);

		var _this = _possibleConstructorReturn(this, (CompileError.__proto__ || Object.getPrototypeOf(CompileError)).call(this, message));

		_this.name = 'CompileError';
		if (!node) {
			return _possibleConstructorReturn(_this);
		}

		var source = node.program.magicString.original;
		var loc = (0, _locate2.default)(source, node.start);

		_this.message = message + (' (' + loc.line + ':' + loc.column + ')');

		_this.stack = new Error().stack.replace(new RegExp('.+new ' + _this.name + '.+\\n', 'm'), '');

		_this.loc = loc;
		_this.snippet = (0, _getSnippet2.default)(source, loc, node.end - node.start);
		return _this;
	}

	_createClass(CompileError, [{
		key: 'toString',
		value: function toString() {
			return this.name + ': ' + this.message + '\n' + this.snippet;
		}
	}]);

	return CompileError;
}(Error);

exports.default = CompileError;